/*
   FILNAME:			

   PURPOSE:			

   CREATED BY:		Per Ghosh (email: hulken@algonet.se)
   ENVIRONEMENT:	Visual C++


INFO:


LOGG:
Sign.. Date... Comment........................................................................
	   
*/

#include "stdafx.h"
#include "Modal.h"

#include "frameModal.h"

#include "ModalDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModalDoc

IMPLEMENT_DYNCREATE(CModalDoc, CDocument)

BEGIN_MESSAGE_MAP(CModalDoc, CDocument)
	//{{AFX_MSG_MAP(CModalDoc)
	ON_COMMAND(ID_MODAL_SHOWMODALFRAME, OnModalShowmodalframe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModalDoc construction/destruction

CModalDoc::CModalDoc()
{
	// TODO: add one-time construction code here

}

CModalDoc::~CModalDoc()
{
}

BOOL CModalDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CModalDoc serialization

void CModalDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CModalDoc diagnostics

#ifdef _DEBUG
void CModalDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CModalDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/* ------------------------------------------------------------------------------------------------
 * NAME:    OnModalShowmodalframe()
 * PURPOSE: Here we create a modal window
 */
void CModalDoc::OnModalShowmodalframe() 
{
   CCframeModal* pframeModal; // the window that are to be modal

   // create a frame ( the frame delete it self in PostNcDestroy() )
   pframeModal = new CCframeModal();

   pframeModal->Create( NULL, 
                        _T("This is a modal frame"), 
                        WS_OVERLAPPEDWINDOW, 
                        CFrameWnd::rectDefault, 
                        AfxGetApp()->m_pMainWnd );

   // Disable the application window
   ::EnableWindow( AfxGetApp()->m_pMainWnd->m_hWnd, FALSE );

   // get, translate and dispatch messages until break out with EndModalLoop()
   pframeModal->RunModalLoop( MLF_SHOWONIDLE );

   // destroy the frame
   pframeModal->DestroyWindow();
}
